# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class CreateNodeGroupRequest(JDCloudRequest):
    """
    创建k8s的nodeGroup
要求集群状态为running

    """

    def __init__(self, parameters, header=None, version="v1"):
        super(CreateNodeGroupRequest, self).__init__(
            '/regions/{regionId}/nodeGroups', 'POST', header, version)
        self.parameters = parameters


class CreateNodeGroupParameters(object):

    def __init__(self, regionId, name, clusterId, nodeConfig, initialNodeCount, vpcId, nodeCidr, ):
        """
        :param regionId: 地域 ID
        :param name: 名称（同一用户的 cluster 内部唯一）
        :param clusterId: node group所属的cluster
        :param nodeConfig: 节点组配置
        :param initialNodeCount: nodeGroup初始化大小
        :param vpcId: k8s运行的vpc
        :param nodeCidr: k8s的node的cidr
        """

        self.regionId = regionId
        self.name = name
        self.description = None
        self.clusterId = clusterId
        self.nodeConfig = nodeConfig
        self.initialNodeCount = initialNodeCount
        self.vpcId = vpcId
        self.nodeCidr = nodeCidr
        self.autoRepair = None

    def setDescription(self, description):
        """
        :param description: (Optional) 描述
        """
        self.description = description

    def setAutoRepair(self, autoRepair):
        """
        :param autoRepair: (Optional) 是否开启 node group 的自动修复，默认关闭
        """
        self.autoRepair = autoRepair

